return {
  {
    'neovim/nvim-lspconfig',
    opts = {
      servers = {
        cssls = {},

        emmet_language_server = {
          filetypes = {
            'css',
            'eruby',
            'html',
            'htmlangular',
            'htmldjango',
            'javascriptreact',
            'less',
            'liquid',
            'pug',
            'sass',
            'scss',
            'typescriptreact',
            'vue',
          },
        },

        fish_lsp = {},
        gh_actions_ls = {},

        html = {
          filetypes = { 'html', 'liquid' },
        },

        nil_ls = {
          settings = {
            ['nil'] = {
              flake = {
                autoArchive = true,
                autoEvalInputs = true,
              },
            },
          },
        },

        somesass_ls = {},
        statix = {},
        stylelint_lsp = {},

        -- Fix for nix installation of vue-language-server.
        vtsls = {
          settings = {
            vtsls = {
              tsserver = {
                globalPlugins = {
                  location = nixCats.extra('vue-ls-path'),
                },
              },
            },
          },
        },
      },
    },
  },
}
