return {
  {
    'Wansmer/treesj',
    keys = {
      { '<SPACE>m', require('treesj').toggle, desc = 'toggle join/split' },
      { '<SPACE>j', require('treesj').join, desc = 'join code block' },
      { '<SPACE>p', require('treesj').split, desc = 'split code block' },
    },
    dependencies = { 'nvim-treesitter/nvim-treesitter' },
    opts = {
      use_default_keymaps = false,
      max_join_length = vim.o.textwidth,
    },
  },

  -- Remap key so it doesn't conflict with treesj.
  {
    'gbprod/yanky.nvim',
    keys = {
      {
        '<leader>y',
        function()
          if LazyVim.pick.picker.name == 'telescope' then
            require('telescope').extensions.yank_history.yank_history({})
          else
            vim.cmd([[YankyRingHistory]])
          end
        end,
        mode = { 'n', 'x' },
        desc = 'Open Yank History',
      },
    },
  },
}
